﻿class Sprite
{
	private var _mc:MovieClip
	private var _isActive:Boolean
	
	/*
		Constructor
	*/
	function Sprite(timeline:MovieClip, sourceMc:String, px:Number, py:Number, isActive:Boolean)
	{
		/*
			Initialize the level counter
		*/
		if (_global.lvl == undefined)
			_global.lvl = 0
			
		_mc = timeline.attachMovie(sourceMc, "sprite_" + _global.lvl, _global.lvl)

		_mc._x 		= px
		_mc._y 		= py
		
		_isActive 	= isActive
		
		if (!_isActive) _mc._visible = false
		
		_global.lvl++
	}
	
	public function getClip():MovieClip
	{
		return _mc
	}
	
	public function collides(sp:Sprite):Boolean
	{
		return _mc.hitTest(sp.getClip())
	}
	
	/*
		Getter / Setter for _isActive property
	*/
	public function get isActive():Boolean
	{
		return _isActive
	}
	
	public function set isActive(flag:Boolean):Void
	{
		_isActive = flag
		if (_isActive)
			_mc._visible = true
		else
			_mc._visible = false
	}
	
	public function get x():Number
	{
		return _mc._x
	}
	
	public function get y():Number
	{
		return _mc._y
	}
	
	public function set x(x:Number):Void
	{
		_mc._x = x
	}
	
	public function set y(y:Number):Void
	{
		_mc._y = y
	}
	
	public function getWidth():Number
	{
		return _mc._width
	}
	
	public function getHeight():Number
	{
		return _mc._height
	}
	
}